from concurrent import futures
import grpc
import add_service_pb2
import add_service_pb2_grpc

# service implementation, use the add_service_pb2_grpc.py file
class AddServiceServicer(add_service_pb2_grpc.AddServiceServicer):
    def Add(self, request, context):
        result = request.a + request.b
        return add_service_pb2.AddResponse(result=result)

# start the server on port 8000
def serve():
    server = grpc.server(futures.ThreadPoolExecutor(max_workers=5)) # 5 threads for example
    add_service_pb2_grpc.add_AddServiceServicer_to_server(AddServiceServicer(), server)
    server.add_insecure_port('[::]:8000')
    print("Server starts on port 8000")
    server.start()
    server.wait_for_termination()

if __name__ == '__main__':
    serve()